% Started as a simple project to learn Video coding
% as iam very new to video coding but have a working knowledge
% on Image, Audio and Speech coding
% 
% Please use this as a basic learning tool for Video Coding

% Started Jan 20, 2010

% Limitations:
% 1. Only MPEG 2 Simple Profile, currently supported
%   i.e. Doesn't use B-frames, therefore no backward or interpolated prediction
%   Consequently, no picture reordering is required Suitable for low-delay applications
% 2. No Rate Control Module Used, thus bit-rate cannot be set
% 3. Chroma format chosen is 4:2:0

% Currently the code reads AVI files and converts them to YUV format
% its an AVI -> MPEG2 encoder

% The Encoding Sequence followed here is
% I P I P I P I P I P ......
% Since we are working on Simple Profile there will be 
% no reordering. i.e. no B Frames
clear all
clc
dct_pred = [0 0 0];
global dct_pred;
SIZE_MAX = 176;
global SIZE_MAX;
warning off MATLAB:mir_warning_variable_used_as_function
filename = 'test.avi'; % Its a true color video
out_filename = 'test.m2v';
f_out = fopen(out_filename,'w');
Len= 100;%length(aviread(filename)); % If you know number of frames avoid this, unless you are working on Intel QuadCore :)

Horizontal_Size = SIZE_MAX;
Vertical_Size = SIZE_MAX;
load intra_quant_mat.mat;
load alternate_scan.mat;
load DClumtab.mat;
load DCchromtab.mat;
load dct_code_tab.mat; % rows are runs, col are in order code, level
BitStream = [];

    
BitStream = Alignbits(BitStream);
BitStream = PutSequenceHeader(BitStream);
BitStream = Alignbits(BitStream);
BitStream = PutSequenceExtension(BitStream);
BitStream = Alignbits(BitStream);
BitStream = PutSequenceDisplayExtension(BitStream);
BitStream = Alignbits(BitStream);
BitStream = PutGOPHeader(BitStream);
    
tempmat(1:8,1:8) = 16;
tempmat(1,1) = 1;
QUANT = 4;
intra_quant_mat(1,1) = intra_quant_mat(1,1)/QUANT;
for index = 10:25
    frame = aviread(filename,index);
    % frame.colormap is NULL since its a true image
    [frame_Y frame_U frame_V] = rgb2yuv(frame.cdata,'YUV420_8','BT601_f'); % Assume its 240 x 240
    % imshow(frame_Y);
    % imshow(yuv2rgb(frame_Y,frame_U,frame_V,'YUV420_8','BT601_f'));
    % These YUV 4:2:0 frames will be used for encoding the avi file into
    % MPEG2 file
    % Currently trying all I's
    frame_Y =  (im2double(frame_Y).*255 - 128); % I had forgotten this -128, Basic: Just out of my mind
    frame_U =  (im2double(frame_U).*255 - 128);
    frame_V =  (im2double(frame_V).*255 - 128);
    %floor(dct2(tt)+0.5)
    frame_Y_trfmd = zeros(SIZE_MAX,SIZE_MAX);
    frame_U_trfmd = zeros(SIZE_MAX/2,SIZE_MAX/2);
    frame_V_trfmd = zeros(SIZE_MAX/2,SIZE_MAX/2);
    
%     frame_V = zeros(SIZE_MAX/2,SIZE_MAX/2);
%     frame_U = zeros(SIZE_MAX/2,SIZE_MAX/2);
    
    %frame_Y(1:8,1:8) = magic(8);
    
    for row = 1:8:SIZE_MAX
        for col = 1:8:SIZE_MAX
            frame_Y_trfmd(row:row+7,col:col+7) = floor(dct2(frame_Y(row:row+7, col:col+7)) + 0.5);                        
        end        
    end
    
    for row = 1:8:SIZE_MAX/2
        for col = 1:8:SIZE_MAX/2
            frame_U_trfmd(row:row+7,col:col+7) = floor(dct2(frame_U(row:row+7, col:col+7)) + 0.5);    
            frame_V_trfmd(row:row+7,col:col+7) = floor(dct2(frame_V(row:row+7, col:col+7)) + 0.5);  
        end        
    end

    BitStream = Alignbits(BitStream);
    BitStream = PutPictureHeader(BitStream);
    BitStream = Alignbits(BitStream);
    BitStream = PutPictureCodingExtn(BitStream);
    
    % initial quantization stepsize (at the beginning of picture) set to a
    % resonable value, say 20  
    
    % Assume all macroblocks share same quantization
    % isn't it foolish !!! YES IT IS
    
    for row = 1:8:SIZE_MAX
        for col = 1:8:SIZE_MAX
            frame_Y_trfmd_Quant(row:row+7,col:col+7) = round((frame_Y_trfmd(row:row+7,col:col+7)./(intra_quant_mat.*QUANT)).*tempmat);                        
        end        
    end
    
    for row = 1:8:SIZE_MAX/2
        for col = 1:8:SIZE_MAX/2
            frame_U_trfmd_Quant(row:row+7,col:col+7) = round((frame_U_trfmd(row:row+7,col:col+7)./(intra_quant_mat.*QUANT)).*tempmat);    
            frame_V_trfmd_Quant(row:row+7,col:col+7) = round((frame_V_trfmd(row:row+7,col:col+7)./(intra_quant_mat.*QUANT)).*tempmat);  
        end        
    end
    
    
    if(0)
        for row = 1:8:SIZE_MAX
            for col = 1:8:SIZE_MAX
                frame_Y_trfmd_IQuant(row:row+7,col:col+7) = floor(idct2(round((frame_Y_trfmd_Quant(row:row+7,col:col+7).*(intra_quant_mat.*QUANT))./tempmat)));                        
            end        
        end
        
        for row = 1:8:SIZE_MAX/2
            for col = 1:8:SIZE_MAX/2
                frame_U_trfmd_IQuant(row:row+7,col:col+7) = floor(idct2(round((frame_U_trfmd_Quant(row:row+7,col:col+7).*(intra_quant_mat.*QUANT))./tempmat)));    
                frame_V_trfmd_IQuant(row:row+7,col:col+7) = floor(idct2(round((frame_V_trfmd_Quant(row:row+7,col:col+7).*(intra_quant_mat.*QUANT))./tempmat)));  
            end        
        end
        
        %  imshow(yuv2rgb(frame_Y_trfmd_IQuant,frame_U_trfmd_IQuant,frame_V_trfmd_IQuant,'YUV420_8','BT601_f'));
    end
    % Macroblock escape and address increment
    % Looping for every macro block.
    ind_slice = 0;
    for ind1 = 1:16:SIZE_MAX %240/16
        for ind2 = 1:16:SIZE_MAX %240/16
            
            if(ind2 == 1)
                BitStream = Alignbits(BitStream);
                BitStream = PutSliceHeader(ind_slice, BitStream); % Each row is a slice
                ind_slice = ind_slice + 1;
                
                % Reset the dct predictors here
                dct_pred = [ 0 0 0];
            end
            %BitStream = Alignbits(BitStream);
            BitStream = PutMacroBlock(BitStream);
            
            crntMB_YPart = frame_Y_trfmd_Quant(ind1:ind1+15, ind2:ind2+15);
            crntMB_UPart = frame_U_trfmd_Quant(round([ind1:2:ind1+15]./2), round([ind2:2:ind2+15]./2));
            crntMB_VPart = frame_V_trfmd_Quant(round([ind1:2:ind1+15]./2), round([ind2:2:ind2+15]./2));
            
            % All 4 8x8 blocks of crntMB_YPart, crntMB_UPart and crntMB_VPart
            BitStream = code_MB_Ypart(crntMB_YPart, BitStream);
            BitStream = code_MB_Upart(crntMB_UPart, BitStream);
            BitStream = [BitStream dec2bin(6,4)]; % End of Block -- normative block punctuation
            BitStream = code_MB_Vpart(crntMB_VPart, BitStream);
            BitStream = [BitStream dec2bin(6,4)]; % End of Block -- normative block punctuation
            
            % End of Block
            
            
        end
    end
    BitStream = Alignbits(BitStream);
    out_cod = reshape(BitStream,8,length(BitStream)/8)';
    out_cod = bin2dec(out_cod);
    fwrite(f_out,out_cod,'uint8');
    BitStream=[];
    disp('.....');
end

% Put Sequence End code
BitStream = Alignbits(BitStream);
BitStream = [BitStream  dec2bin(439,32)];

out_cod = reshape(BitStream,8,length(BitStream)/8)';
out_cod = dec2bin(out_cod)';
fwrite(f_out,out_cod,'uint8');
fclose(f_out);